#!/bin/bash

Bps=0
Bps1=0
#sleep for atleast 10sec to normalize the error value
s=10


#disable kernel console prints, but dmesg will have prints
sysctl -w kernel.printk="4 4 1 7"
#sysctl -w kernel.printk="7 4 1 7" # This is to re-enable them

which bc
[ $? != 0 ] && echo "No bc command" && exit 1234;

ds_reg=20f0
us_reg=2e00
ds_pattern=0x003203d0
us_pattern=0x00323810

while true; do
	dmesg -c > /dev/null;
	echo r 2e00 8 >/proc/driver/vrx518/atm0/mem;
	prev0=$(dmesg | head -n 2 | tail -n 1 | grep -o -E '0x00323810: [0-9a-f]++' | awk '{ print $2 }')

	dmesg -c > /dev/null;
	echo r 2e00 8 >/proc/driver/vrx518/atm1/mem;
	prev1=$(dmesg | head -n 2 | tail -n 1 | grep -o -E '0x00323810: [0-9a-f]++' | awk '{ print $2 }')

	#sleeping for a sec
	sleep $s;

	dmesg -c > /dev/null;
	echo r 2e00 8 >/proc/driver/vrx518/atm0/mem;
	curr0=$(dmesg | head -n 2 | tail -n 1 | grep -o -E '0x00323810: [0-9a-f]++' | awk '{ print $2 }')

	dmesg -c > /dev/null;
	echo r 2e00 8 >/proc/driver/vrx518/atm1/mem;
	curr1=$(dmesg | head -n 2 | tail -n 1 | grep -o -E '0x00323810: [0-9a-f]++' | awk '{ print $2 }')

	#calculation
	[ -z $prev0 ] && continue;
	prev0=$(echo $prev0 | tr "a-z" "A-Z")
	prev0=$(echo "ibase=16; $prev0" | bc)

	[ -z $prev1 ] && continue;
	prev1=$(echo $prev1 | tr "a-z" "A-Z")
	prev1=$(echo "ibase=16; $prev1" | bc)

	[ -z $curr0 ] && continue;
	curr0=$(echo $curr0 | tr "a-z" "A-Z")
	curr0=$(echo "ibase=16; $curr0" | bc)

	[ -z $curr1 ] && continue;
	curr1=$(echo $curr1 | tr "a-z" "A-Z")
	curr1=$(echo "ibase=16; $curr1" | bc)

	Bps=$((curr0-prev0))
	Bps1=$((curr1-prev1))
	Kbps=$(((48*8*Bps)/s/1000))
	Kbps1=$(((48*8*Bps1)/s/1000))
	fract=$(((48*8*Bps)%(s*1000)))
	fract1=$(((48*8*Bps1)%(s*1000)))
	echo "PPEFW MaxThruput US: L0: ${Kbps}.$(((fract*10)/1000)) Kbps, L1: ${Kbps1}.$(((fract1*10)/1000)) Kbps"
done
